
const char page[] PROGMEM = R"=====(
<!DOCTYPE HTML>
<html>
  <head>
    <title>Sopht MQP</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="icon" type="image/png" href="favicon.png">
    <style>
      
 html {font-family: Arial,Helvetica, sans-serif; display: inline-block; text-align: center;}
      p {font-size: 1.3em;}
      body {margin: 0;}
      .topnav {overflow: hidden; background-color: #a90b0b; color: white; font-size: 1.5rem;}
      .content {padding: 30px; }
      .card {background-color: white; box-shadow: 0px 0px 10px 1px rgba(140,140,140,.5); border: 1px solid #a90b0b;; border-radius: 15px;}
      .card.header {background-color: #a90b0b;; color: white; border-bottom-right-radius: 0px; border-bottom-left-radius: 0px; border-top-right-radius: 12px; border-top-left-radius: 12px;}
      .cards {max-width: 700px; margin: 0 auto; display: grid; grid-gap: 2rem; grid-template-columns: repeat(auto-fit, minmax(300px, 1fr));}
      .reading {font-size: 2.8rem;}
      .packet {color: #bebebe;}
      .temperatureColor {color: #fd7e14;}
      .humidityColor {color: #1b78e2;}
      .ValveColor{color: #183153;}

      
      /* ----------------------------------- Toggle Switch */
      .switch {
        position: relative;
        display: inline-block;
        width: 70px;
        height: 34px;
      }

      .switch input {display:none;}

      .sliderTS {
        position: absolute;
        cursor: pointer;
        top: 0;
        left: 0;
        right: 0;
        bottom: 0;
        background-color: #D3D3D3;
        -webkit-transition: .4s;
        transition: .4s;
        border-radius: 34px;
      }

      .sliderTS:before {
        position: absolute;
        content: "";
        height: 26px;
        width: 26px;
        left: 4px;
        bottom: 4px;
        background-color: #f7f7f7;
        -webkit-transition: .4s;
        transition: .4s;
        border-radius: 50%;
      }

      input:checked + .sliderTS {
        background-color: #62c934;
      }

      input:focus + .sliderTS {
        box-shadow: 0 0 1px #2196F3;
      }

      input:checked + .sliderTS:before {
        -webkit-transform: translateX(26px);
        -ms-transform: translateX(26px);
        transform: translateX(36px);
      }

      .sliderTS:after {
        content:'OFF';
        color: white;
        display: block;
        position: absolute;
        transform: translate(-50%,-50%);
        top: 50%;
        left: 70%;
        font-size: 10px;
        font-family: Verdana, sans-serif;
      }

      input:checked + .sliderTS:after {  
        left: 25%;
        content:'ON';
      }
      /* ----------------------------------- */
      
      /* ----------------------------------- Slider */
      .slidecontainer {
        width: 100%;
      }

      .slider {
        -webkit-appearance: none;
        width: 50%;
        height: 10px;
        border-radius: 5px;
        background: #d3d3d3;
        outline: none;
        opacity: 0.7;
        -webkit-transition: .2s;
        transition: opacity .2s;
      }

      .slider:hover {
        opacity: 1;
      }

      .slider::-webkit-slider-thumb {
        -webkit-appearance: none;
        appearance: none;
        width: 20px;
        height: 20px;
        border-radius: 50%;
        background: #1b78e2;
        cursor: pointer;
      }

      .slider::-moz-range-thumb {
        width: 20px;
        height: 20px;
        border-radius: 50%;
        background: #1b78e2;
        cursor: pointer;
      }

      h1 
          font-size: 1.8rem;
          color: white;
        }

      .topnav {overflow: hidden; background-color: #0A1128;}
        .state {
          font-size: 0.8rem;
          color:#1282A2;
        }


  
 
  /* ----------------------------------- */
  </style>

  </head>
  
 
  <body>


    <div class="topnav">
        <h1>Sopht MQP </h1>
    </div>
      
    <br><br>

    <div class="content">
        <div class="cards">

          <div class="card">
            <div class="card header">
              <h2>MOVEMENTS</h2>
            </div>

            <br>

            <h4 class="ValveColorr">Wave: </h4> 

            <label class="switch">
              <input type="checkbox" id="wave" onclick="send_LinearActuator_State_Cmd('ESP32Slave2','wave','50')">
              <div class="sliderTS"></div>
            </label>

            <br>
            <br><br> 

             <h4 class="ValveColorr">All air: </h4> 

            <label class="switch">
              <input type="checkbox" id="all" onclick="send_LinearActuator_State_Cmd('ESP32Slave1','all','80')">
              <div class="sliderTS"></div>
            </label>

            <br>
            <br><br> 

            <h4 class="ValveColorr">Circle: </h4> 

            <label class="switch">
              <input type="checkbox" id="circle" onclick="send_LinearActuator_State_Cmd('ESP32Slave2','circle','51')">
              <div class="sliderTS"></div>
            </label>

            <br>
            <br><br>

            <h4 class="ValveColorr">Grasp</h4> 

            <label class="switch">
              <input type="checkbox" id="graps" onclick="send_Finger2_State_Cmd('ESP32Slave1','ESP32Slave2','graps','80')">
              <div class="sliderTS"></div>
            </label>

            <br>

            <div class="slidecontainer">
              <input type="range"  onchange="updateSlidergrasp(this)"min="0" max="100" value="0" class="slider" id="Grasp1">
              <p class="state">Percentage of flexion: <span id="GraspSliderValue1"></span></p>
            </div>

            <br> 

            <br><br>  


            <h4 class="ValveColorr">Emergency Stop: </h4> 

            <label class="switch">
              <input type="checkbox" id="emergency" onclick="send_Emergency_State_Cmd('ESP32Slave1','ESP32Slave2','emergency','100')">
              <div class="sliderTS"></div>
            </label>

            <br>
            <br><br> 

          </div>


          <div class="card">
            <div class="card header">
              <h2>WRIST</h2>
            </div>

            <br>

            <h4 class="ValveColorr">Front motion: </h4> 

            <label class="switch">
              <input type="checkbox" id="togfront" onclick="send_LinearActuator_State_Cmd('ESP32Slave2','togfront','19')">
              <div class="sliderTS"></div>
            </label>

            <br>

            <h4 class="ValveColorr">Back motion: </h4> 

            <label class="switch">
              <input type="checkbox" id="togback" onclick="send_LinearActuator_State_Cmd('ESP32Slave2','togback','17')">
              <div class="sliderTS"></div>
            </label>

            <br>

            <h4 class="ValveColorr">Left motion: </h4> 
            <label class="switch">
              <input type="checkbox" id="togleft" onclick="send_LinearActuator_State_Cmd('ESP32Slave2','togleft','16')">
              <div class="sliderTS"></div>
            </label>

            <br>

            <h4 class="ValveColorr">Right motion: </h4> 
            <label class="switch">
              <input type="checkbox" id="togright" onclick="send_LinearActuator_State_Cmd('ESP32Slave2','togright','5')">
              <div class="sliderTS"></div>
            </label>

            <br>

            <h4 class="ValveColor">Clock rotation :</h4> 
            <div class="slidecontainer">
              <input type="range"  onchange="updateSliderstepmotor(this)"min="0" max="180" value="0" class="slider" id="Stepmotor1">
              <p class="state">Degrees: <span id="sliderStepMotorValue1"></span></p>
            </div>
          
            <br>

            <h4 class="ValveColor">Counterclock rotation:</h4> 
            <div class="slidecontainer">
              <input type="range"  onchange="updateSliderstepmotor(this)"min="0" max="180" value="0" class="slider" id="Stepmotor2">
              <p class="state">Degrees: <span id="sliderStepMotorValue2"></span></p>
            </div>
            
            <br>
          </div>  
        

          <div class="card">
            <div class="card header">
              <h2>FINGERS</h2>
            </div>

            <br>

            <h4 class="ValveColorr">Index Finger </h4> 

            <label class="switch">
              <input type="checkbox" id="index" onclick="send_Finger_State_Cmd('ESP32Slave1','index','60')">
              <div class="sliderTS"></div>
            </label>

            <br>

            <div class="slidecontainer">
              <input type="range"  onchange="updateSliderfinger(this)"min="0" max="100" value="0" class="slider" id="Finger4">
              <p class="state">Percentage of flexion: <span id="FingersliderValue4"></span></p>
            </div>

            <br> 
            <br><br> 

           <h4 class="ValveColorr">Ring Finger </h4> 

            <label class="switch">
              <input type="checkbox" id="pointer" onclick="send_Finger_State_Cmd('ESP32Slave1','pointer','61')">
              <div class="sliderTS"></div>
            </label>

            <br>
           <div class="slidecontainer">
              <input type="range"  onchange="updateSliderfinger(this)"min="0" max="100" value="0" class="slider" id="Finger2">
              <p class="state">Percentage of flexion: <span id="FingersliderValue2"></span></p>
            </div>

            <br> 

            <br><br> 

           <h4 class="ValveColorr">Middle Finger </h4> 

            <label class="switch">
              <input type="checkbox" id="middle"onclick="send_Finger_State_Cmd('ESP32Slave1','middle','62')">
              <div class="sliderTS"></div>
            </label>

            <br>

            <div class="slidecontainer">
              <input type="range"  onchange="updateSliderfinger(this)"min="0" max="100" value="0" class="slider" id="Finger3">
              <p class="state">Percentage of flexion: <span id="FingersliderValue3"></span></p>
            </div>

            <br> 

            <br><br> 

           <h4 class="ValveColorr">Pinky Finger  </h4> 

            <label class="switch">
              <input type="checkbox" id="ring" onclick="send_Finger_State_Cmd('ESP32Slave1','ring','63')">
              <div class="sliderTS"></div>
            </label>

            <br>

            <div class="slidecontainer">
              <input type="range"  onchange="updateSliderfinger(this)"min="0" max="100" value="0" class="slider" id="Finger5">
              <p class="state">Percentage of flexion:<span id="FingersliderValue5"></span></p>
            </div>

            <br> 

            <br><br>  

           <h4 class="ValveColorr">Thumb</h4> 

            <label class="switch">
              <input type="checkbox" id="thumb" onclick="send_Finger_State_Cmd('ESP32Slave1','thumb','64')">
              <div class="sliderTS"></div>
            </label>

            <br>

            <div class="slidecontainer">
              <input type="range"  onchange="updateSliderfinger(this)"min="0" max="100" value="0" class="slider" id="Finger1">
              <p class="state">Percentage of flexion: <span id="FingersliderValue1"></span></p>
            </div>

            <br> 

            <br><br>        

          </div>

          <div class="card">
            <div class="card header">
              <h2>Finger Selectionr</h2>
            </div>

            <br>

            <h4 class="ValveColorr">Pinky enable </h4> 

            <label class="switch">
              <input type="checkbox" id="pinkye" onclick="send_Finger2_State_Cmd('ESP32Slave1','ESP32Slave2','pinkye','81')">
              <div class="sliderTS"></div>
            </label>

            <br>


           <h4 class="ValveColorr">Ring enable </h4> 

            <label class="switch">
              <input type="checkbox" id="ringe" onclick="send_Finger2_State_Cmd('ESP32Slave1','ESP32Slave2','ringe','82')">
              <div class="sliderTS"></div>
            </label>

            <br>
        

           <h4 class="ValveColorr">Middle enable </h4> 

            <label class="switch">
              <input type="checkbox" id="middlee"onclick="send_Finger2_State_Cmd('ESP32Slave1','ESP32Slave2','middlee','83')">
              <div class="sliderTS"></div>
            </label>

            <br>

            

           <h4 class="ValveColorr">Index enable  </h4> 

            <label class="switch">
              <input type="checkbox" id="indexe" onclick="send_Finger2_State_Cmd('ESP32Slave1','ESP32Slave2','indexe','84')">
              <div class="sliderTS"></div>
            </label>

            <br>

            <h4 class="ValveColorr">Thumb enable </h4> 

            <label class="switch">
              <input type="checkbox" id="thumbe" onclick="send_Finger2_State_Cmd('ESP32Slave1','ESP32Slave2','thumbe','85')">
              <div class="sliderTS"></div>
            </label>

            <br>


            <br><br>        

          </div>


        </div>  
      </div>  

      <br><br> 
        
      <div class="cards">
          <h1>TROUBLESHOOTING </h1>
      </div>
        
      <br><br>
      <div class="content">
        <div class="cards">
            
          <div class="card">
            <div class="card header">
              <h2>VALVES </h2>
            </div>
            <br>
              
            <h4 class="ValveColor">Valve 1 : </h4> 
            <div class="slidecontainer">
              <input type="range"  onchange="updateSliderPWM(this)" min="0" max="100" value="0" class="slider" id="mySlider1">
              <p class="state">Duty cycle: <span id="sliderValue1"></span> &percnt;</p>
            </div>

            <br>

            <h4 class="ValveColor">Valve 2 : </h4> 
            <div class="slidecontainer">
              <input type="range" onchange="updateSliderPWM(this)" min="0" max="100" value="0" class="slider" id="mySlider2">
              <p class="state">Duty cycle: <span id="sliderValue2"></span> &percnt;</p>
            </div>

            <br>

            <h4 class="ValveColor">Valve 3 : </h4> 
            <div class="slidecontainer">
              <input type="range" onchange="updateSliderPWM(this)" min="0" max="100" value="0" class="slider" id="mySlider3">
              <p class="state">Duty cycle: <span id="sliderValue3"></span> &percnt;</p>
            </div>

            <br>

            <h4 class="ValveColor">Valve 4 : </h4> 
            <div class="slidecontainer">
              <input type="range" onchange="updateSliderPWM(this)" min="0" max="100" value="0" class="slider" id="mySlider4">
              <p class="state">Duty cycle: <span id="sliderValue4"></span> &percnt;</p>
            </div>

            <br>

            <h4 class="ValveColor">Valve 5 : </h4> 
            <div class="slidecontainer">
              <input type="range" onchange="updateSliderPWM(this)"  min="0" max="100" value="0" class="slider" id="mySlider5">
              <p class="state">Duty cycle: <span id="sliderValue5"></span> &percnt;</p>
            </div>

            <br><br>
            <h4 class="ValveColor">Valve 6 : </h4> 
            <div class="slidecontainer">
              <input type="range" onchange="updateSliderPWM(this)"  min="0" max="100" value="0" class="slider" id="mySlider6">
              <p class="state">Duty cycle: <span id="sliderValue6"></span> &percnt;</p>
            </div>

            <br>
        
            <h4 class="ValveColorr">Pump: </h4> 
            <label class="switch">
              <input type="checkbox" id="togPump" onclick="send_LinearActuator_State_Cmd('ESP32Slave1','togPump','19')">
              <div class="sliderTS"></div>
            </label>
            <br>
            <br><br>  

             <h4 class="ValveColorr">Calibration: </h4> 
            <label class="switch">
              <input type="checkbox" id="cal" onclick="send_LinearActuator_State_Cmd('ESP32Slave1','cal','70')">
              <div class="sliderTS"></div>
            </label>
            <br>
            <br><br> 

          </div>
            
          <div class="card">
            <div class="card header">
              <h2>MOTORS</h2>
            </div>

            <br>

            <h4 class="ValveColor">Motor 1 :</h4> 
            <div class="slidecontainer">
              <input type="range"  onchange="updateSlidermotor(this)"min="0" max="180" value="0" class="slider" id="Motorslider1">
              <p class="state">Degrees: <span id="sliderMotorValue1"></span></p>
            </div>

            <br>

            <h4 class="ValveColor">Motor 2 :</h4> 

            <div class="slidecontainer">
              <input type="range"  onchange="updateSlidermotor(this)"min="0" max="180" value="0" class="slider" id="Motorslider2">
              <p class="state">Degrees: <span id="sliderMotorValue2"></span></p>
            </div>

            <br>

            <h4 class="ValveColor">Motor 3 :</h4> 
            <div class="slidecontainer">
              <input type="range"  onchange="updateSlidermotor(this)"min="0" max="180" value="0" class="slider" id="Motorslider3">
              <p class="state">Degrees: <span id="sliderMotorValue3"></span></p>
            </div>

            <br>

            <h4 class="ValveColor">Motor 4 :</h4> 
            <div class="slidecontainer">
              <input type="range"  onchange="updateSlidermotor(this)"min="0" max="180" value="0" class="slider" id="Motorslider4">
              <p class="state">Degrees: <span id="sliderMotorValue4"></span></p>
            </div>

            <br>

            <h4 class="ValveColor">Motor 5 :</h4> 
            <div class="slidecontainer">
              <input type="range"  onchange="updateSlidermotor(this)"min="0" max="180" value="0" class="slider" id="Motorslider5">
              <p class="state">Degrees: <span id="sliderMotorValue5"></span></p>
            </div>

            <br>

            <h4 class="ValveColor">Motor 6 :</h4> 
            <div class="slidecontainer">
              <input type="range"  onchange="updateSlidermotor(this)"min="0" max="180" value="0" class="slider" id="Motorslider6">
              <p class="state">Degrees: <span id="sliderMotorValue6"></span></p>
            </div>
            <br>

           

          </div>

          

        </div>
      </div>  
    

    
    <script>

    //------------------------------------------------------------ The variables for the slider valves.
        var sliderValve1 = document.getElementById("mySlider1");
        var last_slidervalve1_val = 0;
      
        var sliderValve2 = document.getElementById("mySlider2");
        var last_slidervalve2_val = 0;
      
        var sliderValve3 = document.getElementById("mySlider3");
        var last_slidervalve3_val = 0;
      
        var sliderValve4 = document.getElementById("mySlider4");
        var last_slidervalve4_val = 0;
      
        var sliderValve5 = document.getElementById("mySlider5");
        var last_slidervalve5_val = 0;

        var sliderValve6 = document.getElementById("mySlider6");
        var last_slidervalve6_val = 0;
      
      //------------------------------------------------------------ The variables for the slider motors.
        var sliderMotor1 = document.getElementById("Motorslider1");
        var last_sliderMotor1_val = 0;

        var sliderMotor2 = document.getElementById("Motorslider2");
        var last_sliderMotor2_val = 0;

        var sliderMotor3 = document.getElementById("Motorslider3");
        var last_sliderMotor3_val = 0;

        var sliderMotor4 = document.getElementById("Motorslider4");
        var last_sliderMotor4_val = 0;

        var sliderMotor5 = document.getElementById("Motorslider5");
        var last_sliderMotor5_val = 0;

        var sliderMotor6 = document.getElementById("Motorslider6");
        var last_sliderMotor6_val = 0;

        var sliderstepMotor1 = document.getElementById("Stepmotor1");
        var last_sliderStepMotor1_val = 0;

        var sliderstepMotor2= document.getElementById("Stepmotor2");
        var last_sliderStepMotor2_val = 0;

      //------------------------------------------------------------
      //------------------------------------------------------------ The variables for the slider finger.

        var sliderFinger1 = document.getElementById("Finger1");
        var last_sliderFinger1_val = 0;

        var sliderFinger2 = document.getElementById("Finger2");
        var last_sliderFinger2_val = 0;

        var sliderFinger3 = document.getElementById("Finger3");
        var last_sliderFinger3_val = 0;

        var sliderFinger4 = document.getElementById("Finger4");
        var last_sliderFinger4_val = 0;

        var sliderFinger5 = document.getElementById("Finger5");
        var last_sliderFinger5_val = 0;

        var sliderGrasp1 = document.getElementById("Grasp1");
        var last_sliderGrasp1_val = 0;

        
        let sliders_used = "";
        //------------------------------------------------------------
        //function to get duty cycle value on screen
        
        function updateSliderPWM(element) {
        var sliderNumber = element.id.charAt(element.id.length-1);
        var sliderValue = document.getElementById(element.id).value;
        document.getElementById("sliderValue"+sliderNumber).innerHTML = sliderValue;
        console.log(sliderValue);
        websocket.send(sliderNumber+"s"+sliderValue.toString());
        }

        
        function updateSlidermotor(element) {
        var sliderNumber = element.id.charAt(element.id.length-1);
        var sliderMotorValue = document.getElementById(element.id).value;
        document.getElementById("sliderMotorValue"+sliderNumber).innerHTML = sliderMotorValue;
        console.log(sliderMotorValue);
        websocket.send(sliderMotorValue+"s"+sliderValue.toString());
        }

        function updateSliderstepmotor(element) {
        var sliderNumber = element.id.charAt(element.id.length-1);
        var sliderStepMotorValue = document.getElementById(element.id).value;
        document.getElementById("sliderStepMotorValue"+sliderNumber).innerHTML = sliderStepMotorValue;
        console.log(sliderStepMotorValue);
        websocket.send(sliderStepMotorValue+"s"+sliderValue.toString());
        }

      
       function updateSliderfinger(element) {
        var sliderNumber = element.id.charAt(element.id.length-1);
        var FingersliderValue = document.getElementById(element.id).value;
        document.getElementById("FingersliderValue"+sliderNumber).innerHTML = FingersliderValue;
        console.log(FingersliderValue);
        websocket.send(FingersliderValue+"s"+sliderValue.toString());
        }

        function updateSlidergrasp(element) {
        var sliderNumber = element.id.charAt(element.id.length-1);
        var GraspSliderValue = document.getElementById(element.id).value;
        document.getElementById("GraspSliderValue"+sliderNumber).innerHTML = GraspSliderValue;
        console.log(GraspSliderValue);
        websocket.send(GraspSliderValue+"s"+sliderValue.toString());
        }


       
        
        //------------------------------------------------------------ The variables for the Timer.
        var myTmr_send;
        var myTmr_send_interval = 250;
        var myTmr_send_start = 1;
        var myTmr_count_to_stop = 0;
        //------------------------------------------------------------
        
      //------------------------------------------------------------ The function called by "Toggle Switch" to control the linear actuator
      function send_LinearActuator_State_Cmd(board,id,gpio,) {
        var tgLEDFlash = document.getElementById(id);
        var tgState;
    
        if (tgLEDFlash.checked == true) tgState = 1;
        if (tgLEDFlash.checked == false) tgState = 0;
    
        send_cmd(board,gpio,tgState);
      }

      function send_Emergency_State_Cmd(board1,board2,id,gpio,) {
        var tgLEDFlash = document.getElementById(id);
        var tgState;
    
        if (tgLEDFlash.checked == true) tgState = 1;
        if (tgLEDFlash.checked == false) tgState = 0;
    
        send_cmd(board1,gpio,tgState);
        send_cmd(board2,gpio,tgState);
      }
      //------------------------------------------------------------


      function send_Finger_State_Cmd(board,id,gpio,) {
        var tgLEDFlash = document.getElementById(id);
        var tgState;
    
        if (tgLEDFlash.checked == true) tgState = 1;
        if (tgLEDFlash.checked == false) tgState = 0;
    
        send_cmd(board,gpio,tgState);
      }

      function send_Finger2_State_Cmd(board1,board2,id,gpio,) {
        var tgLEDFlash = document.getElementById(id);
        var tgState;
    
        if (tgLEDFlash.checked == true) tgState = 1;
        if (tgLEDFlash.checked == false) tgState = 0;
    
        send_cmd(board1,gpio,tgState);
        send_cmd(board2,gpio,tgState);
      }
      
        
        //------------------------------------------------------------ Function to detect when the slider is used and get its value and activate the Timer.
        sliderValve1.oninput = function() {
          sliders_used = "SL1";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }
        sliderValve2.oninput = function() {
          sliders_used = "SL2";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }
      
        sliderValve3.oninput = function() {
          sliders_used = "SL3";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }
      
        sliderValve4.oninput = function() {
          sliders_used = "SL4";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }
      
        sliderValve5.oninput = function() {
          sliders_used = "SL5";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }
          sliderValve6.oninput = function() {
          sliders_used = "SL6";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }
        // ------------------------------------------------------------Motors
          sliderMotor1.oninput = function() {
          sliders_used = "SM1";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }

        sliderMotor2.oninput = function() {
          sliders_used = "SM2";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }

        sliderMotor3.oninput = function() {
          sliders_used = "SM3";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }

        sliderMotor4.oninput = function() {
          sliders_used = "SM4";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }

        sliderMotor5.oninput = function() {
          sliders_used = "SM5";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }

        sliderMotor6.oninput = function() {
          sliders_used = "SM6";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }

        sliderstepMotor1.oninput = function() {
          sliders_used = "SSM1";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }

        sliderstepMotor2.oninput = function() {
          sliders_used = "SSM2";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }


        sliderFinger1.oninput = function() {
          sliders_used = "SP1";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }

        sliderFinger2.oninput = function() {
          sliders_used = "SP2";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }


        sliderFinger3.oninput = function() {
          sliders_used = "SP3";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }

        sliderFinger4.oninput = function() {
          sliders_used = "SP4";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }

        sliderFinger5.oninput = function() {
          sliders_used = "SP5";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }

        sliderGrasp1.oninput = function() {
          sliders_used = "SG1";
          myTmr_count_to_stop = 0;
          if (myTmr_send_start == 1) {
            myTmr_send = setInterval(myTmr_send_LED_PWM_Cmd, myTmr_send_interval);
            myTmr_send_start = 0;
          }
        }
        
        // ---------------------------------------------------------------------- Timer for sending slider values and other data from this page to ESP32.
        function myTmr_send_LED_PWM_Cmd() {
          if (sliders_used == "SL1") {
            if (last_slidervalve1_val != sliderValve1.value) {
              send_cmd('ESP32Slave1',27,sliderValve1.value);
            }
            last_slidervalve1_val = sliderValve1.value;
          }
          
          if (sliders_used == "SL2") {
            if (last_slidervalve2_val != sliderValve2.value) {
              send_cmd('ESP32Slave1',26,sliderValve2.value);
            }
            last_slidervalve2_val = sliderValve2.value;
          }
          
          if (sliders_used == "SL3") {
            if (last_slidervalve3_val != sliderValve3.value) {
              send_cmd('ESP32Slave1',25,sliderValve3.value);
            }
            last_slidervalve3_val = sliderValve3.value;
          }
          if (sliders_used == "SL4") {
            if (last_slidervalve4_val != sliderValve4.value) {
              send_cmd('ESP32Slave1',33,sliderValve4.value);
            }
            last_slidervalve4_val = sliderValve4.value;
          }
          if (sliders_used == "SL5") {
            if (last_slidervalve5_val != sliderValve5.value) {
              send_cmd('ESP32Slave1',32,sliderValve5.value);
            }
            last_slidervalve5_val = sliderValve5.value;
          }

          if (sliders_used == "SL6") {
            if (last_slidervalve6_val != sliderValve6.value) {
              send_cmd('ESP32Slave1',14,sliderValve6.value);
            }
            last_slidervalve6_val = sliderValve6.value;
          }

          if (sliders_used == "SM1") {
            if (last_sliderMotor1_val != sliderMotor1.value) {
              send_cmd('ESP32Slave2',34,sliderMotor1.value);
            }
            last_sliderMotor1_val = sliderMotor1.value;
          }

          if (sliders_used == "SM2") {
            if (last_sliderMotor2_val != sliderMotor2.value) {
              send_cmd('ESP32Slave2',35,sliderMotor2.value);
            }
            last_sliderMotor2_val = sliderMotor2.value;
          }

          if (sliders_used == "SM3") {
            if (last_sliderMotor3_val != sliderMotor3.value) {
              send_cmd('ESP32Slave2',32,sliderMotor3.value);
            }
            last_sliderMotor3_val = sliderMotor3.value;
          }

          if (sliders_used == "SM4") {
            if (last_sliderMotor4_val != sliderMotor4.value) {
              send_cmd('ESP32Slave2',33,sliderMotor4.value);
            }
            last_sliderMotor4_val = sliderMotor4.value;
          }

          if (sliders_used == "SM5") {
            if (last_sliderMotor5_val != sliderMotor5.value) {
              send_cmd('ESP32Slave2',25,sliderMotor5.value);
            }
            last_sliderMotor5_val = sliderMotor5.value;
          }

          if (sliders_used == "SM6") {
            if (last_sliderMotor6_val != sliderMotor6.value) {
              send_cmd('ESP32Slave2',26,sliderMotor6.value);
            }
            last_sliderMotor6_val = sliderMotor6.value;
          }

          if (sliders_used == "SSM1") {
            if (last_sliderStepMotor1_val != sliderstepMotor1.value) {
              send_cmd('ESP32Slave2',22,sliderstepMotor1.value);
            }
            last_sliderStepMotor1_val = sliderstepMotor1.value;
          }

          if (sliders_used == "SSM2") {
            if (last_sliderStepMotor2_val != sliderstepMotor2.value) {
              send_cmd('ESP32Slave2',23,sliderstepMotor2.value);
            }
            last_sliderStepMotor2_val = sliderstepMotor2.value;
          }

            if (sliders_used == "SP1") {
            if (last_sliderFinger1_val != sliderFinger1.value) {
              send_cmd('ESP32Slave1',65,sliderFinger1.value);
            }
            last_sliderFinger1_val = sliderFinger1.value;
          }

            if (sliders_used == "SP2") {
            if (last_sliderFinger2_val != sliderFinger2.value) {
              send_cmd('ESP32Slave1',66,sliderFinger2.value);
            }
            last_sliderFinger2_val = sliderFinger2.value;
          }

            if (sliders_used == "SP3") {
            if (last_sliderFinger3_val != sliderFinger3.value) {
              send_cmd('ESP32Slave1',67,sliderFinger3.value);
            }
            last_sliderFinger3_val = sliderFinger3.value;
          }

            if (sliders_used == "SP4") {
            if (last_sliderFinger4_val != sliderFinger4.value) {
              send_cmd('ESP32Slave1',68,sliderFinger4.value);
            }
            last_sliderFinger4_val = sliderFinger4.value;
          }

            if (sliders_used == "SP5") {
            if (last_sliderFinger5_val != sliderFinger5.value) {
              send_cmd('ESP32Slave1',69,sliderFinger5.value);
            }
            last_sliderFinger5_val = sliderFinger5.value;
          }

           if (sliders_used == "SG1") {
            if (last_sliderGrasp1_val != sliderGrasp1.value) {
              send_cmd('ESP32Slave1',86,sliderGrasp1.value);
              send_cmd('ESP32Slave2',86,sliderGrasp1.value);

            }
            last_sliderGrasp1_val = sliderGrasp1.value;
          }


          myTmr_count_to_stop++;
          if (myTmr_count_to_stop > 5) {
            myTmr_send_start = 1;
            clearInterval(myTmr_send);
          }
        }
        // ---------------------------------------------------------------------- 
        
        // ---------------------------------------------------------------------- XMLHttpRequest to submit data.
        function send_cmd(board,gpio,value) {
          var xhr = new XMLHttpRequest();
          xhr.open("GET", "set_LED?board="+board+"&gpio_output="+gpio+"&val="+value, true);
          xhr.send();
        }
        // ------------------
    </script>
  </body>
</html>
)=====";